CompilerIf #PB_Compiler_OS <> #PB_OS_Windows
  CompilerError("Sorry, at this time only Windows support.")
CompilerEndIf
Dim dmem$(1)
Procedure FT_Init()
  If OpenConsole()= 0
    PrintN("Could not open console")
    End
  EndIf
  If InitSound() = 0
    PrintN("Could initialize sound")
    End
  EndIf
  ConsoleTitle("FreqTracker 1.3")
  ConsoleColor(9, 7)
  ConsoleCursor(10)
EndProcedure
Declare FT_Math(note)
Declare FT_SoundSystem(string_fromfile$)
Declare.s FT_GUI()
Declare.s FT_GUI_File()
Declare FT_GUI_Key_A(cons_y)
Declare FT_GUI_Key_D(cons_x)
Declare FT_GUI_Key_S(cons_y)
Declare FT_GUI_Key_W(cons_x)
Declare FT_GUI_Numbers()
Declare.s FT_File_New()
Declare.s FT_GUI_Tracker(posy)
Declare.s FT_Memory(current_row, rowpos)
Declare.s FT_File_Load()
Declare.s FT_File_Save()
Procedure FT_Write(cons_x, cons_y, helper$)

  EnableGraphicalConsole(1)
  ConsoleLocate(cons_x, cons_y)
  EnableGraphicalConsole(0)
  Print(helper$)
EndProcedure

Procedure FT_GUI_Chng(inc$, cons_x, cons_y, col)
  Shared dmem$()
  Shared ft_pattern
  Shared ft_row
  helper = ((col*15)-15)+7
  If cons_x = helper
    type = 1
    ln = 1
  EndIf
  helper = ((col*15)-15)+8
  If cons_x = helper
    type = 1
    ln = 2
  EndIf
  helper = ((col*15)-15)+9
  If cons_x = helper
    type = 1
    ln = 3
  EndIf
  helper = ((col*15)-15)+10
  If cons_x = helper
    type = 1
    ln = 4
  EndIf
  helper = ((col*15)-15)+12
  If cons_x = helper
    type = 2
    ln = 1
  EndIf
  helper = ((col*15)-15)+13
  If cons_x = helper
    type = 2
    ln = 2
  EndIf
  helper = ((col*15)-15)+14
  If cons_x = helper
    type = 2
    ln = 3
  EndIf
  helper = ((col*15)-15)+16
  If cons_x = helper
    type = 3
    ln = 1
  EndIf
  helper = ((col*15)-15)+17
  If cons_x = helper
    type = 3
    ln = 2
  EndIf
  helper = ((col*15)-15)+18
  If cons_x = helper
    type = 3
    ln = 3
  EndIf
  helper = ((col*15)-15)+19
  If cons_x = helper
    type = 3
    ln = 4
  EndIf
  
  row_mat = (cons_y - 4) + (16*(ft_pattern-1))
  
  
  helper = ((type-1)*8)+col
  temp$ = dmem$(row_mat-1)
  helper$ = StringField(temp$, helper, ",")
  chng$ = ""
  
  If type = 1
    If ln = 1
      helper = Val(Mid(helper$, 1, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Str(helper)+Mid(helper$, 2, 1)+Mid(helper$, 3, 1)+Mid(helper$, 4, 1)
    ElseIf ln = 2
      helper = Val(Mid(helper$, 2, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Str(helper)+Mid(helper$, 3, 1)+Mid(helper$, 4, 1)
    ElseIf ln = 3
      helper = Val(Mid(helper$, 3, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Mid(helper$, 2, 1)+Str(helper)+Mid(helper$, 4, 1)
    ElseIf ln = 4
      helper = Val(Mid(helper$, 4, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Mid(helper$, 2, 1)+Mid(helper$, 3, 1)+Str(helper)
    EndIf
    If Val(chng$) > 9999
      chng$ = "9999"
      
    EndIf
    
    
    
    
    
  ElseIf type = 2
    If ln = 1
      helper = Val(Mid(helper$, 1, 1))+Val(inc$+"1")
      If helper > 1
        helper = 1
      ElseIf helper < 0
        
        helper = 0
      EndIf
      chng$ = Str(helper)+Mid(helper$, 2, 1)+Mid(helper$, 3, 1)
    ElseIf ln = 2
      
      helper = Val(Mid(helper$, 2, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Str(helper)+Mid(helper$, 3, 1)
    ElseIf ln = 3
      helper = Val(Mid(helper$, 3, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Mid(helper$, 2, 1)+Str(helper)
    EndIf
    If Val(chng$) > 100
      chng$ = "100"
      
      
    ElseIf Val(chng$) < 0
      
      chng$ = "0"
      
    EndIf
  ElseIf type = 3
    
    
    If ln = 1
      chng$ = inc$+Mid(helper$, 2, 1)+Mid(helper$, 3, 1)+Mid(helper$, 4, 1)
    ElseIf ln = 2
      helper = Val(Mid(helper$, 2, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Str(helper)+Mid(helper$, 3, 1)+Mid(helper$, 4, 1)
    ElseIf ln = 3
      helper = Val(Mid(helper$, 3, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Mid(helper$, 2, 1)+Str(helper)+Mid(helper$, 4, 1)
    ElseIf ln = 4
      helper = Val(Mid(helper$, 4, 1))+Val(inc$+"1")
      If helper > 9
        helper = 9
      EndIf
      If helper < 0
        helper = 0
      EndIf
      chng$ = Mid(helper$, 1, 1)+Mid(helper$, 2, 1)+Mid(helper$, 3, 1)+Str(helper)
    EndIf
    
    If Val(chng$) > 100
      chng$ = "+100"
      
      
    EndIf
    If Val(chng$) < -100
      chng$ = "-100"
      
      
    EndIf
  EndIf
  row$ = dmem$(row_mat-1)
  helper = ((type-1)*8)+col
  If helper <> 1
    If helper <> 24
      For b = 1 To helper-1
        row_2$ = row_2$+StringField(row$, b, ",")+","
      Next
      row_2$ = row_2$+chng$+","
      For b = helper+1 To 23
        row_2$ = row_2$+StringField(row$, b, ",")+","
      Next
      row_2$ = row_2$+StringField(row$, 24, ",")
    ElseIf helper = 24
      For b = 1 To 23
        row_2$ = row_2$+StringField(row$, b, ",")+","
      Next
      row_2$ = row_2$+chng$
    EndIf
  ElseIf helper = 1
    row_2$ = chng$+","
    For b = 2 To 23
      row_2$ = row_2$+StringField(row$, b, ",")+","
    Next
    row_2$ = row_2$+StringField(row$, b, ",")
  EndIf
  
  dmem$(row_mat-1) = row_2$
EndProcedure
Procedure FT_GUI_Play()
  ConsoleColor(9, 7)
  Shared ft_meta$
  Shared cons_y
  Shared ft_row
  Shared ft_pattern
  Shared sndpck$
  Shared dmem$()
  For c = 1 To 8
    LoadSound(c, ".\snd\"+sndpck$+"\"+StringField(ft_meta$, c, ",")+".wav")
    SoundVolume(c, 0)
    PlaySound(c, #PB_Sound_Loop)
  Next
  delaytime$ = StringField(ft_meta$, 9, ",")
  helper_2 = ft_row/16
  ft_pattern = 0
  For testvar = 1 To helper_2
    ft_pattern = ft_pattern+1
    helper = 16*(testvar-1)
    counter = 3
    FT_GUI_Numbers()
    
    For k = 1+helper To 16+helper
      string_fromfile$ = ""
      counter = counter+1
      For e = 1 To 24
        string_fromfile$ = string_fromfile$+Str(Val(StringField(dmem$(k-1), e,",")))+","
      Next
      
      FT_SoundSystem(string_fromfile$)
      FT_GUI_Tracker(counter)
      movekey$ = ""
      movekey$ = Inkey()
      
      If movekey$ = Chr(8) Or movekey$ = Chr(27) Or movekey$ = " "
        StopSound(-1)
        helper = 16*(ft_pattern-1)
        FT_GUI_Numbers()
        FT_Write(6, counter+1, Chr(186))
        ProcedureReturn
      EndIf
      Delay(Val(delaytime$))
    Next
    FT_Write(6, 20, Chr(186))
  Next
  
  StopSound(-1)
  FT_Write(6, 20, Chr(186))
  helper = 16*(ft_pattern-1)
  FT_GUI_Numbers()
EndProcedure
Procedure FT_Math(note)
  note_freq = note*109.091
  ProcedureReturn note_freq
EndProcedure
Procedure FT_SoundSystem(string_fromfile$)
  For c = 1 To 8
    SoundFrequency(c, FT_Math(Val(StringField(string_fromfile$, c, ","))))
    helper = c + 8
    SoundVolume(c, Val(StringField(string_fromfile$, helper, ",")))
    helper = c + 16
    SoundPan(c, Val(StringField(string_fromfile$, helper, ",")))
  Next
EndProcedure
Procedure.s FT_GUI_File()
  Shared cons_x
  Shared cons_y
  ConsoleCursor(0)
  dec1 = 14
  dec2 = 9
  dec3 = 9
  dec4 = 1
  Repeat
    If dec4 = 1
      ConsoleColor(7, 9)
      OpenFile(1, ".\gui\file")
      For r = 2 To 7
        EnableGraphicalConsole(1)
        ConsoleLocate(0, r-1)
        EnableGraphicalConsole(0)
        Print(ReadString(1))
      Next
      EnableGraphicalConsole(1)
      ConsoleColor(7, dec1)
      ConsoleLocate(0, 3)
      Print(" NEW   ")
      ConsoleColor(7, dec2)
      ConsoleLocate(0, 4)
      Print(" LOAD  ")
      ConsoleColor(7, dec3)
      ConsoleLocate(0, 5)
      Print(" SAVE  ")
      EnableGraphicalConsole(0)
    ElseIf dec4 = 2
      ConsoleColor(7, 9)
      OpenFile(1, ".\gui\play")
      FT_Write(5, 1, ReadString(1))
      FT_Write(5, 2, ReadString(1))
    EndIf
    movekey$ = ""
    Repeat
      movekey$ = Inkey()
      Delay(1)
    Until movekey$ <> ""
    
    If movekey$ = Chr(8)
      ProcedureReturn
    EndIf
    
    If movekey$ = Chr(27)
      ProcedureReturn
    EndIf
    
    If movekey$ = " "
      If dec4 = 2
        FT_GUI_Play()
      EndIf
      If dec4 = 1
        If dec1 = 14
          FT_File_New()
          cons_x = 7
          cons_y = 5
          ProcedureReturn
        ElseIf dec2 = 14
          FT_File_Load()
          cons_x = 7
          cons_y = 5
          ProcedureReturn
        ElseIf dec3 = 14
          FT_File_Save()
          ProcedureReturn
        EndIf
      EndIf
    EndIf
    If movekey$ = "a"
      If dec4 = 1
        dec4 = 2
        ConsoleColor(9, 7)
        EnableGraphicalConsole(1)
        ConsoleLocate(0, 0)
        EnableGraphicalConsole(0)
        OpenFile(1, ".\gui\gui")
        For r = 1 To 21
          PrintN(ReadString(1))
        Next
        Print(ReadString(1))
        FT_GUI_Numbers()
      ElseIf dec4 =2
        dec4 = 1
        ConsoleColor(9, 7)
        EnableGraphicalConsole(1)
        ConsoleLocate(0, 0)
        EnableGraphicalConsole(0)
        OpenFile(1, ".\gui\gui")
        For r = 1 To 21
          PrintN(ReadString(1))
        Next
        Print(ReadString(1))
        FT_GUI_Numbers()
      EndIf
    EndIf
    If movekey$ = "d"
      If dec4 = 1
        dec4 = 2
        ConsoleColor(9, 7)
        EnableGraphicalConsole(1)
        ConsoleLocate(0, 0)
        EnableGraphicalConsole(0)
        OpenFile(1, ".\gui\gui")
        For r = 1 To 21
          PrintN(ReadString(1))
        Next
        Print(ReadString(1))
        FT_GUI_Numbers()
      ElseIf dec4 =2
        dec4 = 1
        ConsoleColor(9, 7)
        EnableGraphicalConsole(1)
        ConsoleLocate(0, 0)
        EnableGraphicalConsole(0)
        OpenFile(1, ".\gui\gui")
        For r = 1 To 21
          PrintN(ReadString(1))
        Next
        Print(ReadString(1))
        FT_GUI_Numbers()
      EndIf
    EndIf
    If dec4 = 1
      If movekey$ = "w"
        If dec1 = 14
          dec1 = 9
          dec3 = 14
        ElseIf dec2 = 14
          dec2 = 9
          dec1 = 14
        ElseIf dec3 = 14
          dec3 = 9
          dec2 = 14
        EndIf
      EndIf
    EndIf
    If dec4 = 1
      If movekey$ = "s"
        If dec1 = 14
          dec1 = 9
          dec2 = 14
        ElseIf dec2 = 14
          dec2 = 9
          dec3 = 14
        ElseIf dec3 = 14
          dec3 = 9
          dec1 = 14
        EndIf
      EndIf
    EndIf
  ForEver
EndProcedure

Procedure FT_GUI_Key_W(cons_y)
  Shared ft_pattern
  Shared dmem$()
  Shared ft_row
  
  cons_y = cons_y - 1
  If cons_y < 5
    If ft_pattern <> 1
      ft_pattern = ft_pattern - 1
      cons_y = 20
      helper = ((ft_pattern)*16)-1
      huehue = (ft_pattern+1)*16
      temp = 0
      
      
      If huehue = ft_row
        temp = 0
        For v = 1 To 16
          If dmem$(helper+v) = "0000,0000,0000,0000,0000,0000,0000,0000,000,000,000,000,000,000,000,000,+000,+000,+000,+000,+000,+000,+000,+000"
            temp = temp + 1
          EndIf
        Next
        If temp = 16
          ft_row = ft_row - 16
          ReDim dmem$(ft_row-1)
          ReDim dmem$(ft_row)
        EndIf
      EndIf
      
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
      
    Else
      cons_y = 5
    EndIf
  EndIf
  
  
  ProcedureReturn cons_y
EndProcedure
Procedure FT_GUI_Key_A(cons_x)
  For r = 0 To 90 Step 30
    If cons_x = 12+r
      cons_x = 11+r
    EndIf
    If cons_x = 16+r
      cons_x = 15+r
      Break
    EndIf
    If cons_x = 22+r
      cons_x = 20+r
      Break
    EndIf
    If cons_x = 27+r
      cons_x = 26+r
      Break
    EndIf
    If cons_x = 31+r
      cons_x = 30+r
      Break
    EndIf
    If r <> 90
      If cons_x = 37+r
        cons_x = 35+r
        Break
      EndIf
    EndIf
  Next
  cons_x = cons_x - 1
  If cons_x < 7
    cons_x = 7
  EndIf
  ProcedureReturn cons_x
EndProcedure
Procedure FT_GUI_Key_S(cons_y)
  Shared ft_pattern
  Shared dmem$()
  Shared ft_row
  cons_y = cons_y + 1
  If cons_y > 20
    ft_pattern = ft_pattern + 1
    helper = (ft_pattern*16)-16
    If helper = ft_row
      ft_row = ft_row+16
      ReDim dmem$(ft_row)
      For x = 1 To 16
        dmem$(ft_row-x) = "0000,0000,0000,0000,0000,0000,0000,0000,000,000,000,000,000,000,000,000,+000,+000,+000,+000,+000,+000,+000,+000"
      Next
    EndIf
    ConsoleCursor(0)
    FT_GUI_Numbers()
    ConsoleCursor(10)
    cons_y = 5
  EndIf
  
  ProcedureReturn cons_y
EndProcedure
Procedure FT_GUI_Key_D(cons_x)
  For r = 0 To 90 Step 30
    If cons_x = 10+r
      cons_x = 11+r
      Break
    EndIf
    If cons_x = 14+r
      cons_x = 15+r
      Break
    EndIf
    If cons_x = 19+r
      cons_x = 21+r
      Break
    EndIf
    If cons_x = 25+r
      cons_x = 26+r
      Break
    EndIf
    If cons_x = 29+r
      cons_x = 30+r
      Break
    EndIf
    If cons_x = 34+r
      cons_x = 36+r
      Break
    EndIf
    If r <> 90
      If cons_x = 34+r
        cons_x = 36+r
        Break
      EndIf
    EndIf
  Next
  cons_x = cons_x + 1
  If cons_x > 124
    cons_x = 124
  EndIf
  ProcedureReturn cons_x
EndProcedure
Procedure FT_GUI_Numbers()
  Shared ft_meta$
  Shared row1$
  Shared ft_pattern
  Shared dmem$()
  For v = 1 To 16
    EnableGraphicalConsole(1)
    ConsoleLocate(1, 4+v)
    EnableGraphicalConsole(0)
    helper = ((ft_pattern*16)-16)+v
    If Len(Str(helper)) = 1
      helper$ = "    "+Str(helper)
    ElseIf Len(Str(helper)) = 2
      helper$ = "   "+Str(helper)
    ElseIf Len(Str(helper)) = 3
      helper$ = "  "+Str(helper) 
    ElseIf Len(Str(helper)) = 4
      helper$ = " "+Str(helper) 
    ElseIf Len(Str(helper)) = 5
      helper$ = Str(helper) 
    EndIf
    PrintN(helper$)
  Next
  helper_2 = 1
  For n = 8 To 113 Step 15
    EnableGraphicalConsole(1) 
    ConsoleLocate(n, 3)
    EnableGraphicalConsole(0)
    PrintN(UCase(StringField(ft_meta$, helper_2, ",")+"]"))
    helper_2 = helper_2 + 1
  Next
  EnableGraphicalConsole(1)
  ConsoleLocate(51, 1)
  EnableGraphicalConsole(0)
  PrintN(UCase(StringField(ft_meta$, 9, ",")+"]"))
  For s = 1 To 16
    helper = ((ft_pattern-1)*16)+s-1
    row$ = dmem$(helper)
    
    helper_2 = 1
    For n = 7 To 112 Step 15
      FT_Write(n, 4+s, UCase(StringField(row$, helper_2, ",")))
      FT_Write(n+5, 4+s, UCase(StringField(row$, helper_2+8, ",")))
      FT_Write(n+9, 4+s, UCase(StringField(row$, helper_2+16, ",")))
      helper_2=helper_2+1
    Next
  Next
  
  
EndProcedure
Procedure.s FT_GUI_Tracker(posy)
  If posy <> 4
    FT_Write(6, posy, Chr(186))
    FT_Write(6, posy+1, Chr(16))
  Else
    FT_Write(6, posy+1, Chr(16))
  EndIf
EndProcedure
Procedure.s FT_GUI()
  Shared ft_meta$
  OpenFile(1, ".\gui\gui")
  For r = 1 To 21
    PrintN(ReadString(1))
  Next
  Print(ReadString(1))
  ConsoleCursor(0)
  FT_GUI_Numbers()
  ConsoleCursor(10)
  cons_x = 7
  cons_y = 5
  EnableGraphicalConsole(1)
  ConsoleLocate(cons_x, cons_y)
  EnableGraphicalConsole(0)
  Repeat
    movekey$ = ""
    Repeat
      movekey$ = Inkey()
      Delay(1)
    Until movekey$ <> ""
    col = ((cons_x-6)+15)/15
    
    If movekey$ = "+"
      FT_GUI_Chng("+", cons_x, cons_y, col)
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
    ElseIf movekey$ = "-"
      FT_GUI_Chng("-", cons_x, cons_y, col)
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
    ElseIf movekey$ = "/"
      helper = Val(StringField(ft_meta$, 9, ","))-1
      If helper > 1000
        helper = 1000
      ElseIf helper < 1
        helper = 1
      EndIf
      ft_meta$ = StringField(ft_meta$, 1, ",")+","+StringField(ft_meta$, 2, ",")+","+StringField(ft_meta$, 3, ",")+","+StringField(ft_meta$, 4, ",")+","+StringField(ft_meta$, 5, ",")+","+StringField(ft_meta$, 6, ",")+","+StringField(ft_meta$, 7, ",")+","+StringField(ft_meta$, 8, ",")+","+Str(helper)
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
    ElseIf movekey$ = "*"
      helper = Val(StringField(ft_meta$, 9, ","))+1
      If helper > 1000
        helper = 1000
      ElseIf helper < 1
        helper = 1
      EndIf
      
      ft_meta$ = StringField(ft_meta$, 1, ",")+","+StringField(ft_meta$, 2, ",")+","+StringField(ft_meta$, 3, ",")+","+StringField(ft_meta$, 4, ",")+","+StringField(ft_meta$, 5, ",")+","+StringField(ft_meta$, 6, ",")+","+StringField(ft_meta$, 7, ",")+","+StringField(ft_meta$, 8, ",")+","+Str(helper)
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
    ElseIf movekey$ = "w"
      cons_y = FT_GUI_Key_W(cons_y)
    ElseIf movekey$ = "a"
      cons_x = FT_GUI_Key_A(cons_x)
    ElseIf movekey$ = "s"
      cons_y = FT_GUI_Key_S(cons_y)
    ElseIf movekey$ = "d"
      cons_x = FT_GUI_Key_D(cons_x)
    ElseIf movekey$ = Chr(9)

      ft_meta2$ = ""

      If UCase(StringField(ft_meta$, col, ",")) = "REC1"
        temp$ = "REC2"
      ElseIf UCase(StringField(ft_meta$, col, ",")) = "REC2"
        temp$ = "SAW"
      ElseIf UCase(StringField(ft_meta$, col, ",")) = "SAW"
        temp$ = "TRI"
      ElseIf UCase(StringField(ft_meta$, col, ",")) = "TRI"
        temp$ = "SINE"
      ElseIf UCase(StringField(ft_meta$, col, ",")) = "SINE"
        temp$ = "NOISE"
      ElseIf UCase(StringField(ft_meta$, col, ",")) = "NOISE"
        temp$ = "NULL"
      ElseIf UCase(StringField(ft_meta$, col, ",")) = "NULL"
        temp$ = "REC1"
            EndIf
            
            If col = 1
              ft_meta2$ = temp$+","
              For d = 2 To 9
                ft_meta2$ = ft_meta2$+StringField(ft_meta$, d, ",")+","
              Next
              ft_meta$ = Mid(ft_meta2$, 1, Len(ft_meta2$)-1)
            Else
              
              For d = 1 To col-1
                ft_meta2$ = ft_meta2$+StringField(ft_meta$, d, ",")+","
              Next
              ft_meta2$ = ft_meta2$+temp$+","
              For d = col+1 To 9
                ft_meta2$ = ft_meta2$+StringField(ft_meta$, d, ",")+","
              Next
              ft_meta$ = Mid(ft_meta2$, 1, Len(ft_meta2$)-1)
            EndIf
            
              
            
        
        
        
        
      ConsoleColor(9, 7)
      EnableGraphicalConsole(1)
      ConsoleLocate(0, 0)
      EnableGraphicalConsole(0)
      OpenFile(1, ".\gui\gui")
      For r = 1 To 21
        PrintN(ReadString(1))
      Next
      Print(ReadString(1))
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
    ElseIf movekey$ = Chr(8) Or movekey$ = Chr(27)
      ft_gui_file()
      ConsoleColor(9, 7)
      EnableGraphicalConsole(1)
      ConsoleLocate(0, 0)
      EnableGraphicalConsole(0)
      OpenFile(1, ".\gui\gui")
      For r = 1 To 21
        PrintN(ReadString(1))
      Next
      Print(ReadString(1))
      ConsoleCursor(0)
      FT_GUI_Numbers()
      ConsoleCursor(10)
    EndIf
    EnableGraphicalConsole(1)
    ConsoleLocate(cons_x, cons_y)
    EnableGraphicalConsole(0)
  ForEver
EndProcedure
Procedure.s FT_File_New()
  Shared ft_meta$
  Shared dmem$()
  Shared ft_row
  Shared ft_pattern
  ft_meta$ = "rec1,rec1,rec1,rec2,saw,saw,sine,noise,100"
  ReDim dmem$(16)
  For c = 0 To 15
    dmem$(c) ="0000,0000,0000,0000,0000,0000,0000,0000,000,000,000,000,000,000,000,000,+000,+000,+000,+000,+000,+000,+000,+000"
  Next
  
  ft_row = 16
  ft_pattern = 1
EndProcedure
Procedure.s FT_File_Load()
  If FileSize(".\songs\") <> -2
    Open$ = OpenFileRequester("Choose a file...", ".\", "All files (*.*)|*.*|FreqTracker-Files (*.fqt)|*.fqt", 0)
  Else
    Open$ = OpenFileRequester("Choose a file...", ".\songs\", "All files (*.*)|*.*|FreqTracker-Files (*.fqt)|*.fqt", 0)
  EndIf
  If Open$ = ""
    ProcedureReturn
  EndIf
  Shared ft_meta$
  Shared dmem$()
  Shared ft_row
  Shared ft_pattern
  OpenFile(1, Open$)
  ft_meta$ = ReadString(1)
  Dim dmem$(1)
  helper = 0
  Repeat
    ReDim dmem$(helper)
    dmem$(helper) = ReadString(1)
    helper = helper +1
  Until Eof(1) <> 0
  
  ft_row = helper
  ft_pattern = 1
EndProcedure
Procedure.s FT_File_Save()
  If FileSize(".\songs\") <> -2
    Save$ = SaveFileRequester("Save your music...", ".\", "FreqTracker-Files (*.fqt)|*.fqt", 0)
  Else
    Save$ = SaveFileRequester("Save your music...", ".\songs\", "FreqTracker-Files (*.fqt)|*.fqt", 0)
  EndIf
  If Save$ = ""
    ProcedureReturn
  EndIf
  Shared ft_meta$
  Shared dmem$()
  Shared ft_row
  CreateFile(1, Save$)
  WriteStringN(1, ft_meta$)
  For s = 0 To ft_row
    WriteStringN(1, dmem$(s))
  Next
EndProcedure

FT_Init()
sndpck$ = ProgramParameter()
If sndpck$ = ""
  sndpck$ = "std"
EndIf 
If FileSize(".\snd\"+sndpck$) <> -2
  sndpck$ = "std"
EndIf
If FileSize(".\snd\"+sndpck$) <> -2
  PrintN("Could not find standard soundpack")
  End
EndIf
Dim dmem$(15)
ft_meta$ = "rec1,rec1,rec1,rec2,saw,saw,noise,noise,125"
dmem$(0) = "0466,0000,0000,0349,0116,0058,0440,0440,006,000,000,032,032,032,000,000,+050,+025,+000,+000,-048,+048,-040,+040"
dmem$(1) = "0587,0466,0000,0349,0116,0058,0440,0440,012,004,000,048,032,032,000,000,+050,+025,+000,+000,-042,+042,-040,+040"
dmem$(2) = "0698,0587,0466,0349,0116,0058,0440,0440,018,008,002,048,032,032,000,000,+050,+025,+000,+000,-036,+036,-040,+040"
dmem$(3) = "0466,0698,0587,0349,0116,0058,0440,0440,024,012,004,048,032,032,000,000,+050,+025,+000,+000,-030,+030,-040,+040"
dmem$(4) = "0587,0466,0698,0349,0116,0058,0440,0440,030,016,006,048,032,032,000,000,+050,+025,+000,+000,-024,+024,-040,+040"
dmem$(5) = "0698,0587,0466,0349,0116,0058,0440,0440,036,020,008,048,032,032,000,000,+050,+025,+000,+000,-018,+018,-040,+040"
dmem$(6) = "0466,0698,0587,0349,0116,0058,0440,0440,042,024,010,048,032,032,000,000,+050,+025,+000,+000,-012,+012,-040,+040"
dmem$(7) = "0587,0466,0698,0349,0116,0058,0440,0440,048,028,012,048,032,032,000,000,+050,+025,+000,+000,-006,+006,-040,+040"
dmem$(8) = "0698,0587,0466,0349,0116,0058,0440,0440,048,028,012,048,032,032,003,000,+050,+025,+000,+000,+006,-006,-040,+040"
dmem$(9) = "0466,0698,0587,0349,0116,0058,0440,0440,042,024,010,032,032,032,000,006,+050,+025,+000,+000,+012,-012,-040,+040"
dmem$(10) ="0587,0466,0698,0466,0116,0058,0440,0440,036,020,008,032,032,032,009,000,+050,+025,+000,+000,+018,-018,-040,+040"
dmem$(11) ="0698,0587,0466,0466,0116,0058,0440,0440,030,016,006,048,032,032,000,012,+050,+025,+000,+000,+024,-024,-040,+040"
dmem$(12) ="0466,0698,0587,0466,0116,0058,0440,0440,024,012,004,048,032,032,015,000,+050,+025,+000,+000,+030,-030,-040,+040"
dmem$(13) ="0587,0466,0698,0466,0116,0058,0440,0440,018,008,003,048,032,032,000,018,+050,+025,+000,+000,+036,-036,-040,+040"
dmem$(14) ="0698,0587,0466,0466,0116,0058,0440,0440,012,004,002,048,032,032,021,000,+050,+025,+000,+000,+042,-042,-040,+040"
dmem$(15) ="0466,0698,0698,0466,0116,0058,0440,0440,006,002,001,032,032,032,000,024,+050,+025,+000,+000,+048,-048,-040,+040"
ft_row = 16
ft_pattern = 1
FT_GUI()
End
; IDE Options = PureBasic 5.00 (Windows - x86)
; ExecutableFormat = Console
; CursorPosition = 891
; FirstLine = 853
; Folding = ---
; EnableThread
; EnableXP
; EnableUser
; Executable = ..\ft.exe
; EnablePurifier